SystemOrganization addCategory: #AttractorModelisation!

DynamicComposableModel subclass: #UISecondVersion
	instanceVariableNames: 'modelview plus slider lcolor varValues minus attr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initialize
	self initialize: Attractor new! !

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initialize: arg1
	attr := arg1.
	super initialize.
	self
		initializeWidgets;
		extent: 600 @ 480! !

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initializeWidgets
	| tmp2 tmp10 tmp12 tmp14 |
	self
		instantiateModels: #(#view #RoassalModel #xtview #RoassalModel #ytview #RoassalModel #ztview #RoassalModel #plus #ButtonModel #slider #SliderModel #lcolor #CheckBoxModel #varValues #LabelModel #minus #ButtonModel).
	tmp2 := SpecLayout composed.
	tmp2
		newColumn: [ :arg1 | 
			| tmp4 |
			tmp4 := arg1.
			tmp4
				add: #view;
				addSplitter;
				add: #xtview;
				addSplitter;
				add: #ytview;
				addSplitter;
				add: #ztview;
				newRow: [ :arg2 | 
					| tmp6 |
					tmp6 := arg2.
					tmp6
						add: #varValues;
						add: #lcolor;
						add: #slider ]
					height: 25;
				newRow: [ :arg3 | 
					| tmp8 |
					tmp8 := arg3.
					tmp8
						add: #minus;
						addSplitter;
						add: #plus ]
					height: 25 ].
	layout := tmp2 yourself.
	self view
		script: [ :arg4 :arg5 | 
			arg4 addAll: attr elements.
			arg5 camera focusOnCenter ].
	self xtview
		script: [ :arg6 :arg7 | 
			arg6 addAll: (attr elementsForGraphAt: 1).
			arg7 camera focusOnCenter ].
	self ytview
		script: [ :arg8 :arg9 | 
			arg8 addAll: (attr elementsForGraphAt: 2).
			arg9 camera focusOnCenter ].
	self ztview
		script: [ :arg10 :arg11 | 
			arg10 addAll: (attr elementsForGraphAt: 3).
			arg11 camera focusOnCenter ].
	tmp10 := self minus.
	tmp10
		label: 'r--';
		state: false;
		action: [ attr r: attr r - 1.
			self refresh ].
	tmp12 := self plus.
	tmp12
		label: 'r++';
		state: false;
		action: [ attr r: attr r + 1.
			self refresh ].
	self varValues
		label: 'sigma=' , attr sigma asString , '   r=' , attr r asString.
	self lcolor
		whenChangedDo: [ :arg12 | 
			arg12
				ifTrue: [ attr ds connectColor: Color green.
					self refresh ]
				ifFalse: [ attr ds
						disconnect;
						connectColor: Color transparent.
					self refresh ] ].
	tmp14 := self slider.
	tmp14
		whenValueChangedDo: [ :arg13 | 
			attr sigma: arg13.
			self refresh ];
		min: 0;
		max: 10;
		label: '0<=sigma<=10'! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
layout
	^ layout! !

!UISecondVersion methodsFor: 'use' stamp: ''!
openView
	self openWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'use' stamp: ''!
refresh
	attr rebuild.
	self varValues
		label: 'sigma=' , attr sigma asString , '   r=' , attr r asString.
	self
		needRebuild: false;
		buildWithSpecLayout: layout! !

Object subclass: #Attractor
	instanceVariableNames: 'sigma r p dt system initState from to view stepper solver state values b ds elementsAndEdges attrView xValues yValues zValues graphList viewList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Attractor methodsFor: 'accessing' stamp: ''!
b
	^ b! !

!Attractor methodsFor: 'as yet unclassified' stamp: ''!
buildRTGrapher
	| tmp2 tmp4 |
	b := RTGrapher new.
	ds := RTData new.
	tmp2 := ds dotShape ellipse.
	tmp2
		size: 1;
		color: Color blue.
	ds points: values.
	tmp4 := ds.
	tmp4
		x: [ :arg1 | arg1 at: 1 ];
		y: [ :arg2 | arg2 at: 2 ].
	b
		add: ds;
		build! !

!Attractor methodsFor: 'as yet unclassified' stamp: ''!
buildRTGrapher: arg1
	| tmp1 tmp2 tmp4 |
	tmp1 := RTGrapher new.
	tmp2 := RTData new.
	tmp4 := tmp2 dotShape ellipse.
	tmp4
		size: 1;
		color: Color blue.
	tmp2
		points: arg1;
		connectColor: Color red;
		y: #yourself.
	tmp1
		add: tmp2;
		build.
	graphList add: tmp1! !

!Attractor methodsFor: 'as yet unclassified' stamp: ''!
buildRTGrapher: arg1 withColor: arg2
	| tmp1 tmp2 tmp4 |
	tmp1 := RTGrapher new.
	tmp2 := RTData new.
	tmp4 := tmp2 dotShape ellipse.
	tmp4
		size: 1;
		color: Color blue.
	tmp2
		points: arg1;
		connectColor: Color color;
		y: #yourself.
	tmp1
		add: tmp2;
		shouldUseNiceLabels: true;
		build.
	graphList add: tmp1! !

!Attractor methodsFor: 'hooks' stamp: ''!
buildView
	attrView := RTView new.
	attrView @ RTDraggableView.
	elementsAndEdges := b view elements , b view edges.
	attrView addAll: elementsAndEdges.
	attrView canvas camera
		noInitializationWhenOpen;
		scale: 1.5! !

!Attractor methodsFor: 'hooks' stamp: ''!
buildView: arg1
	| tmp1 tmp2 |
	tmp1 := RTView new.
	tmp1 @ RTDraggableView.
	tmp2 := arg1 view elements , arg1 view edges.
	tmp1 addAll: elementsAndEdges.
	tmp1 canvas camera
		noInitializationWhenOpen;
		scale: 1.5.
	viewList add: tmp1! !

!Attractor methodsFor: 'accessing' stamp: ''!
ds
	^ ds! !

!Attractor methodsFor: 'accessing' stamp: ''!
dt: arg1
	dt := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
elements
	^ b view elements! !

!Attractor methodsFor: 'accessing' stamp: ''!
elementsForGraphAt: arg1
	^ (graphList at: arg1) view elements! !

!Attractor methodsFor: 'accessing' stamp: ''!
initState: arg1
	initState := arg1! !

!Attractor methodsFor: 'initialization' stamp: ''!
initialize
	| tmp8 |
	graphList := OrderedCollection new.
	viewList := OrderedCollection new.
	sigma := 10.0.
	r := 28.0.
	p := 8.0 / 3.0.
	dt := 0.1.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	system := ExplicitSystem
		block: [ :arg1 :arg2 | 
			| tmp1 tmp2 tmp3 tmp4 tmp5 tmp6 |
			tmp4 := arg1 at: 1.
			tmp5 := arg1 at: 2.
			tmp6 := arg1 at: 3.
			tmp1 := sigma * (tmp5 - tmp4).
			tmp2 := r * tmp4 - tmp5 - (tmp4 * tmp6).
			tmp3 := -1 * p * tmp6 + (tmp4 * tmp5).
			{tmp1.
			tmp2.
			tmp3} ].
	stepper := RungeKuttaStepper onSystem: system.
	tmp8 := ExplicitSolver new.
	tmp8
		stepper: stepper;
		system: system.
	solver := tmp8 dt: dt.
	state := #(10.0 10.0 10.0).
	values := (0.0 to: 100.0 by: dt)
		collect: [ :arg3 | state := stepper doStep: state time: arg3 stepSize: dt ].
	values
		do: [ :arg4 | xValues add: (arg4 at: 1) ];
		do: [ :arg5 | yValues add: (arg5 at: 2) ];
		do: [ :arg6 | zValues add: (arg6 at: 3) ].
	self
		buildRTGrapher: xValues;
		buildRTGrapher: yValues;
		buildRTGrapher: zValues;
		buildRTGrapher;
		buildView! !

!Attractor methodsFor: 'as yet unclassified' stamp: ''!
openRTGrapher
	b open! !

!Attractor methodsFor: 'accessing' stamp: ''!
p: arg1
	p := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
r
	^ r! !

!Attractor methodsFor: 'accessing' stamp: ''!
r: arg1
	r := arg1! !

!Attractor methodsFor: 'as yet unclassified' stamp: ''!
rebuild
	b build! !

!Attractor methodsFor: 'actions' stamp: 'Antoinezim 2/27/2017 15:54'!
refresh
	attrView signalUpdate ! !

!Attractor methodsFor: 'accessing' stamp: ''!
sigma
	^ sigma! !

!Attractor methodsFor: 'accessing' stamp: ''!
sigma: arg1
	sigma := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
values: arg1
	values := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
view
	^ attrView! !
